/* Defines the address format for DEVS. */

#include "ace/DEV_Addr.h"

#if !defined (__INLINE__)
#include "ace/DEV_Addr.i"
#endif /* __INLINE__ */

ACE_ALLOC_HOOK_DEFINE(ACE_DEV_Addr)

void
ACE_DEV_Addr::dump (void) const
{
}

/* Do nothing constructor. */

ACE_DEV_Addr::ACE_DEV_Addr (void)
  : ACE_Addr (AF_DEV, sizeof this->devname_)
{
  (void) ACE_OS::memset ((void *) &this->devname_, 0, sizeof this->devname_);
}

// Copy constructor. 

ACE_DEV_Addr::ACE_DEV_Addr (const ACE_DEV_Addr &sa)
  : ACE_Addr (AF_DEV, ACE_OS::strlen (this->devname_))
{
  (void) ACE_OS::memcpy ((void *) &this->devname_, (void *) &sa.devname_, sa.get_size ());
}

ACE_DEV_Addr &
ACE_DEV_Addr::operator= (const ACE_DEV_Addr &sa)
{
  if (this != &sa)
    (void) ACE_OS::memcpy ((void *) &this->devname_, (void *) &sa.devname_, sa.get_size ());
  return *this;
}

ACE_DEV_Addr::ACE_DEV_Addr (const char devname[])
{
  this->set (devname);
}

