/* -*- C++ -*- */
/* Defines the ACE_DEV address format. */

INLINE void 
ACE_DEV_Addr::set (const char devname[])
{

  this->ACE_Addr::base_set (AF_DEV, ACE_OS::strlen (devname) );
  (void) ACE_OS::strcpy (this->devname_, devname);
}

// Transform the current address into string format. 

INLINE int
ACE_DEV_Addr::addr_to_string (char s[], size_t len) const
{
  ACE_OS::strncpy (s, this->devname_, len);
  return 0;
}

// Return a pointer to the address. 

INLINE void *
ACE_DEV_Addr::get_addr (void) const
{
  return (void *) &this->devname_;
}

// Compare two addresses for equality. 

INLINE int
ACE_DEV_Addr::operator == (const ACE_Addr &sap) const
{
  return ACE_OS::strcmp (this->devname_,
		   ((ACE_DEV_Addr &) sap).devname_) == 0;
}

/* Compare two addresses for inequality. */

INLINE int
ACE_DEV_Addr::operator != (const ACE_Addr &sap) const
{
  return !((*this) == sap);	/* This is lazy, of course... ;-) */
}

/* Return the path name used for the rendezvous point. */

INLINE const char *
ACE_DEV_Addr::get_path_name (void) const
{
  return this->devname_;
}

