/* -*- C++ -*- */

#include "ace/FIFO.h"

#if !defined (__INLINE__)
#include "ace/FIFO.i"
#endif /* __INLINE__ */

ACE_ALLOC_HOOK_DEFINE(ACE_FIFO)

void
ACE_FIFO::dump (void) const
{
  ACE_TRACE ("ACE_FIFO::dump");
}

int
ACE_FIFO::open (const char *r, int flags, int perms)
{
  ACE_TRACE ("ACE_FIFO::open");
  ACE_OS::strncpy (this->rendezvous_, r, MAXPATHLEN);

  if ((flags & O_CREAT) != 0 
      && ACE_OS::mkfifo (this->rendezvous_, perms) == -1 
      && !(errno == EEXIST))
    return -1;

  this->set_handle (ACE_OS::open (this->rendezvous_, flags));
  return this->get_handle () == ACE_INVALID_HANDLE ? -1 : 0;
}

ACE_FIFO::ACE_FIFO (const char *fifo_name, 
		    int flags, 
		    int perms)
{
  ACE_TRACE ("ACE_FIFO::ACE_FIFO");
  if (this->open (fifo_name, flags, perms) == -1) 
    ACE_ERROR ((LM_ERROR, "%p\n", "ACE_FIFO"));
}

ACE_FIFO::ACE_FIFO (void)
{
  ACE_TRACE ("ACE_FIFO::ACE_FIFO");
}

int
ACE_FIFO::close (void)
{
  ACE_TRACE ("ACE_FIFO::close");
  int result = 0;

  if (this->get_handle () != ACE_INVALID_HANDLE)
    {
      result = ACE_OS::close (this->get_handle ());
      this->set_handle (ACE_INVALID_HANDLE);
    }
 return result;
}

