#if !defined (ACE_MALLOC_C)
#define ACE_MALLOC_C

#include "ace/Malloc.h"

#if !defined (__INLINE__)
#include "ace/Malloc.i"
#endif /* __INLINE__ */

ACE_Name_Node::ACE_Name_Node (void)
{
  ACE_TRACE ("ACE_Name_Node::ACE_Name_Node");
}

ACE_Name_Node::ACE_Name_Node (const char *name, 
			      void *ptr, 
			      ACE_Name_Node *next)
  : pointer_ (ptr), next_ (next)
{
  ACE_TRACE ("ACE_Name_Node::ACE_Name_Node");
  ACE_OS::strcpy (this->name_, name);
}

#if defined (ACE_MALLOC_STATS)
ACE_Malloc_Stats::ACE_Malloc_Stats (void)
  : nblocks_ (0), 
    nchunks_ (0), 
    ninuse_ (0) 
{
  ACE_TRACE ("ACE_Malloc_Stats::ACE_Malloc_Stats");
}

void
ACE_Malloc_Stats::print (void)
{
  ACE_TRACE ("ACE_Malloc_Stats::print");
  int nblocks = this->nblocks_;
  int ninuse  = this->ninuse_;
  int nchunks = this->nchunks_;

  ACE_DEBUG ((LM_DEBUG, "(%P|%t) %8d block(s)\n", nblocks));
  ACE_DEBUG ((LM_DEBUG, "(%P|%t) %8d block(s) in use\n", ninuse));
  ACE_DEBUG ((LM_DEBUG, "(%P|%t) %8d chunk(s)\n", nchunks));
}

#endif /* ACE_MALLOC_STATS */
#endif /* ACE_MALLOC_C */
