/* -*- C++ -*- */

template <class MALLOC> INLINE 
ACE_Allocator_Adapter<MALLOC>::ACE_Allocator_Adapter (const char *pool_name)
  : allocator_ (pool_name)
{ 
  ACE_TRACE ("ACE_Allocator_Adapter<MALLOC>::ACE_Allocator_Adapter");
}

template <class MALLOC> INLINE void *
ACE_Allocator_Adapter<MALLOC>::malloc (size_t nbytes)
{ 
  ACE_TRACE ("ACE_Allocator_Adapter<MALLOC>::malloc");
  return this->allocator_.malloc (nbytes);
}

template <class MALLOC> INLINE void *
ACE_Allocator_Adapter<MALLOC>::calloc (size_t nbytes, 
				       char initial_value)
{ 
  ACE_TRACE ("ACE_Allocator_Adapter<MALLOC>::malloc");
  return this->allocator_.calloc (nbytes, initial_value);
}

template <class MALLOC> INLINE MALLOC &
ACE_Allocator_Adapter<MALLOC>::allocator (void)
{ 
  ACE_TRACE ("ACE_Allocator_Adapter<MALLOC>::allocator");
  return this->allocator_;
}

template <class MALLOC> INLINE void
ACE_Allocator_Adapter<MALLOC>::free (void *ptr)
{
  ACE_TRACE ("ACE_Allocator_Adapter<MALLOC>::free");
  this->allocator_.free (ptr);
}

template <class MALLOC> INLINE int
ACE_Allocator_Adapter<MALLOC>::remove (void)
{
  ACE_TRACE ("ACE_Allocator_Adapter<MALLOC>::remove");
  return this->allocator_.remove ();
}

template <class MALLOC> INLINE int
ACE_Allocator_Adapter<MALLOC>::trybind (const char *name, 
					void *&pointer)
{
  ACE_TRACE ("ACE_Allocator_Adapter<MALLOC>::trybind");
  return this->allocator_.trybind (name, pointer);
}

template <class MALLOC> INLINE int
ACE_Allocator_Adapter<MALLOC>::bind (const char *name, 
				     void *pointer,
				     int duplicates)
{
  ACE_TRACE ("ACE_Allocator_Adapter<MALLOC>::bind");
  return this->allocator_.bind (name, pointer, duplicates);
}

template <class MALLOC> INLINE int
ACE_Allocator_Adapter<MALLOC>::find (const char *name, 
				     void *&pointer)
{
  ACE_TRACE ("ACE_Allocator_Adapter<MALLOC>::find");
  return this->allocator_.find (name, pointer);
}

template <class MALLOC> INLINE int
ACE_Allocator_Adapter<MALLOC>::find (const char *name)
{
  ACE_TRACE ("ACE_Allocator_Adapter<MALLOC>::find");
  return this->allocator_.find (name);
}

template <class MALLOC> INLINE int
ACE_Allocator_Adapter<MALLOC>::unbind (const char *name, void *&pointer)
{
  ACE_TRACE ("ACE_Allocator_Adapter<MALLOC>::unbind");
  return this->allocator_.unbind (name, pointer);
}

template <class MALLOC> INLINE int
ACE_Allocator_Adapter<MALLOC>::unbind (const char *name)
{
  ACE_TRACE ("ACE_Allocator_Adapter<MALLOC>::unbind");
  return this->allocator_.unbind (name);
}

template <class MALLOC> INLINE int
ACE_Allocator_Adapter<MALLOC>::sync (ssize_t len, int flags)
{
  ACE_TRACE ("ACE_Malloc<MEMORY_POOL, LOCK>::sync");
  return this->allocator_.sync (len, flags);
}

template <class MALLOC> INLINE int
ACE_Allocator_Adapter<MALLOC>::sync (void *addr, size_t len, int flags)
{
  ACE_TRACE ("ACE_Malloc<MEMORY_POOL, LOCK>::sync");
  return this->allocator_.sync (addr, len, flags);
}

template <class MALLOC> INLINE int
ACE_Allocator_Adapter<MALLOC>::protect (ssize_t len, int flags)
{
  ACE_TRACE ("ACE_Malloc<MEMORY_POOL, LOCK>::protect");
  return this->allocator_.protect (len, flags);
}

template <class MALLOC> INLINE int
ACE_Allocator_Adapter<MALLOC>::protect (void *addr, size_t len, int flags)
{
  ACE_TRACE ("ACE_Malloc<MEMORY_POOL, LOCK>::protect");
  return this->allocator_.protect (addr, len, flags);
}

template <class MEM_POOL, class LOCK> MEM_POOL &
ACE_Malloc<MEM_POOL, LOCK>::memory_pool (void)
{
  ACE_TRACE ("ACE_Malloc<MEMORY_POOL, LOCK>::memory_pool");
  return this->memory_pool_;
}

template <class MEM_POOL, class LOCK> int
ACE_Malloc<MEM_POOL, LOCK>::sync (ssize_t len, int flags)
{
  ACE_TRACE ("ACE_Malloc<MEMORY_POOL, LOCK>::sync");
  return this->memory_pool_.sync (len, flags);
}

template <class MEM_POOL, class LOCK> int
ACE_Malloc<MEM_POOL, LOCK>::sync (void *addr, size_t len, int flags)
{
  ACE_TRACE ("ACE_Malloc<MEMORY_POOL, LOCK>::sync");
  return this->memory_pool_.sync (addr, len, flags);
}

template <class MEM_POOL, class LOCK> int
ACE_Malloc<MEM_POOL, LOCK>::protect (ssize_t len, int flags)
{
  ACE_TRACE ("ACE_Malloc<MEMORY_POOL, LOCK>::protect");
  return this->memory_pool_.protect (len, flags);
}

template <class MEM_POOL, class LOCK> int
ACE_Malloc<MEM_POOL, LOCK>::protect (void *addr, size_t len, int flags)
{
  ACE_TRACE ("ACE_Malloc<MEMORY_POOL, LOCK>::protect");
  return this->memory_pool_.protect (addr, len, flags);
}
