/* -*- C++ -*- */
// ************************************************************
// ************************************************************
// ************************************************************

INLINE
ACE_Remote_Mutex::ACE_Remote_Mutex (void)
: ACE_Remote_Token_Proxy (ACE_Token_Proxy::MUTEX,
			  ACE_Tokens::MUTEX)
{
  ACE_TRACE ("ACE_Remote_Mutex::ACE_Remote_Mutex");
}

INLINE
ACE_Remote_Mutex::ACE_Remote_Mutex (const ACE_Remote_Mutex &proxy)
: ACE_Remote_Token_Proxy (proxy)
{
  ACE_TRACE ("ACE_Remote_Mutex::ACE_Remote_Mutex");
}

INLINE
ACE_Remote_Mutex::ACE_Remote_Mutex (const char *token_name,
				    int ignore_deadlock,
				    int debug)
: ACE_Remote_Token_Proxy (token_name, 
			  ignore_deadlock,
			  debug,
			  ACE_Token_Proxy::MUTEX,
			  ACE_Tokens::MUTEX)
{
  ACE_TRACE ("ACE_Remote_Mutex::ACE_Remote_Mutex");
}


// ************************************************************
// ************************************************************
// ************************************************************

INLINE
ACE_Remote_RLock::ACE_Remote_RLock (void)
: ACE_Remote_Token_Proxy (ACE_Token_Proxy::RLOCK,
			  ACE_Tokens::RWLOCK)
{
  ACE_TRACE ("ACE_Remote_RLock::ACE_Remote_RLock");
}

INLINE
ACE_Remote_RLock::ACE_Remote_RLock (const ACE_Remote_RLock &proxy)
: ACE_Remote_Token_Proxy (proxy)
{
  ACE_TRACE ("ACE_Remote_RLock::ACE_Remote_RLock");
}

INLINE
ACE_Remote_RLock::ACE_Remote_RLock (const char *token_name,
				    int ignore_deadlock,
				    int debug)
: ACE_Remote_Token_Proxy (token_name, 
			  ignore_deadlock,
			  debug,
			  ACE_Token_Proxy::RLOCK,
			  ACE_Tokens::RWLOCK)
{
  ACE_TRACE ("ACE_Remote_RLock::ACE_Remote_RLock");
}

// ************************************************************
// ************************************************************
// ************************************************************

INLINE
ACE_Remote_WLock::ACE_Remote_WLock (void)
: ACE_Remote_Token_Proxy (ACE_Token_Proxy::WLOCK,
			  ACE_Tokens::RWLOCK)
{
  ACE_TRACE ("ACE_Remote_WLock::ACE_Remote_WLock");
}

INLINE
ACE_Remote_WLock::ACE_Remote_WLock (const ACE_Remote_WLock &proxy)
: ACE_Remote_Token_Proxy (proxy)
{
  ACE_TRACE ("ACE_Remote_WLock::ACE_Remote_WLock");
}

INLINE
ACE_Remote_WLock::ACE_Remote_WLock (const char *token_name,
				    int ignore_deadlock,
				    int debug)
: ACE_Remote_Token_Proxy (token_name, 
			  ignore_deadlock,
			  debug,
			  ACE_Token_Proxy::WLOCK,
			  ACE_Tokens::RWLOCK)
{
  ACE_TRACE ("ACE_Remote_WLock::ACE_Remote_WLock");
}

