#include "ace/SPIPE_Addr.h"

#if !defined (__INLINE__)
#include "ace/SPIPE_Addr.i"
#endif /* __INLINE__ */

ACE_ALLOC_HOOK_DEFINE(ACE_SPIPE_Addr)

void
ACE_SPIPE_Addr::dump (void) const
{
}

// Do nothing constructor. 

ACE_SPIPE_Addr::ACE_SPIPE_Addr (void)
  : ACE_Addr (AF_SPIPE, sizeof this->SPIPE_addr_)
{
  (void) ACE_OS::memset ((void *) &this->SPIPE_addr_, 0, sizeof this->SPIPE_addr_);
}

// Transform the string into the current addressing format.

int
ACE_SPIPE_Addr::string_to_addr (const char s[])
{
  // Need to complete...
  return -1;
}

/* Copy constructor. */

ACE_SPIPE_Addr::ACE_SPIPE_Addr (const ACE_SPIPE_Addr &sa)
  : ACE_Addr (AF_SPIPE,
	      sizeof this->SPIPE_addr_.gid_ + sizeof this->SPIPE_addr_.uid_
	      + ACE_OS::strlen (this->SPIPE_addr_.rendezvous_))
{
  (void) ACE_OS::memcpy ((void *) &this->SPIPE_addr_, (void *)
		   &sa.SPIPE_addr_, sa.get_size ()); 
}

int
ACE_SPIPE_Addr::set (const char rendezvous_point[], 
		     gid_t gid, 
		     uid_t uid)
{
  int len;

  len = sizeof (this->SPIPE_addr_.uid_);
  len += sizeof(this->SPIPE_addr_.gid_);
  this->ACE_Addr::base_set (AF_SPIPE, ACE_OS::strlen (rendezvous_point) + len);
  ACE_OS::strncpy (this->SPIPE_addr_.rendezvous_, rendezvous_point,
	     sizeof this->SPIPE_addr_.rendezvous_);
  this->SPIPE_addr_.gid_ = gid == 0 ? ACE_OS::getgid () : gid;
  this->SPIPE_addr_.uid_ = uid == 0 ? ACE_OS::getuid () : uid;
  return 0;
}

// Create a ACE_Addr from a ACE_SPIPE pathname. 

ACE_SPIPE_Addr::ACE_SPIPE_Addr (const char rendezvous_point[], 
				gid_t gid, 
				uid_t uid)
{
  this->set (rendezvous_point, gid, uid);
}

