/* -*- C++ -*- */

// Transform the current address into string format. 

INLINE int
ACE_SPIPE_Addr::addr_to_string (char s[], size_t len) const
{
  ACE_OS::strncpy (s, this->SPIPE_addr_.rendezvous_, len);
  return 0;
}

// Return the address. 

INLINE void *
ACE_SPIPE_Addr::get_addr (void) const
{
  return (void *) &this->SPIPE_addr_;
}

// Compare two addresses for equality. 

INLINE int
ACE_SPIPE_Addr::operator == (const ACE_Addr &sap) const
{
  return ACE_OS::strcmp (this->SPIPE_addr_.rendezvous_,
			 ((ACE_SPIPE_Addr &) sap).SPIPE_addr_.rendezvous_) == 0;
}

// Compare two addresses for inequality. 

INLINE int
ACE_SPIPE_Addr::operator != (const ACE_Addr &sap) const
{
  return !((*this) == sap);	// This is lazy, of course... ;-)
}

// Return the path name used for the rendezvous point.

INLINE const char *
ACE_SPIPE_Addr::get_path_name (void) const
{
  return this->SPIPE_addr_.rendezvous_;
}

INLINE uid_t
ACE_SPIPE_Addr::user_id (void) const
{
  return this->SPIPE_addr_.uid_;
}

INLINE void	         
ACE_SPIPE_Addr::user_id (uid_t uid)
{
  this->SPIPE_addr_.uid_ = uid;
}

INLINE gid_t
ACE_SPIPE_Addr::group_id (void) const
{
  return this->SPIPE_addr_.gid_;
}

INLINE void
ACE_SPIPE_Addr::group_id (gid_t gid)
{
  this->SPIPE_addr_.gid_ = gid;
}
