/* -*- C++ -*- */

// Get a copy of the underlying representation.

INLINE char *
ACE_CString::rep (void) const
{
  ACE_TRACE ("ACE_CString::rep");
  
  char *new_string = new char[this->len_ + 1];
  ACE_OS::strcpy (new_string, this->rep_);

  return new_string;
}

// Comparison operator.

INLINE int 
ACE_CString::operator== (const ACE_CString &s) const
{
  ACE_TRACE ("ACE_CString::operator==");
  return this->len_ == s.len_
    && ACE_OS::strcmp (this->rep_, s.rep_) == 0;
}

// Comparison operator.

INLINE int 
ACE_CString::operator!= (const ACE_CString &s) const
{
  ACE_TRACE ("ACE_CString::operator!=");
  return !(*this == s);
}

// Get the underlying pointer (does not make a copy, so beware!).

INLINE char *
ACE_SString::rep (void) const
{
  ACE_TRACE ("ACE_SString::rep");
  return this->rep_;
}

// Comparison operator.

INLINE int 
ACE_SString::operator== (const ACE_SString &s) const
{
  ACE_TRACE ("ACE_SString::operator==");
  return this->len_ == s.len_
    && ACE_OS::strcmp (this->rep_, s.rep_) == 0;
}

// Comparison operator.

INLINE int 
ACE_SString::operator!= (const ACE_SString &s) const
{
  ACE_TRACE ("ACE_SString::operator!=");
  return !(*this == s);
}

// Get a copy of the underlying representation.

INLINE wchar_t *
ACE_WString::rep (void) const
{
  ACE_TRACE ("ACE_WString::rep");
  if (this->len_ <= 0)
    return 0;
  else
    {
      wchar_t *t = new wchar_t[this->len_ + 1];
      ACE_OS::memcpy (t, this->rep_, this->len_ * sizeof (wchar_t));

      // null terminate 
      t[this->len_] = 0;

      return t;
    }
}

// Get at the underlying representation directly!

INLINE wchar_t *
ACE_WString::fast_rep (void) const
{
  return this->rep_;
}

// Comparison operator.

INLINE int 
ACE_WString::operator== (const ACE_WString &s) const
{
  ACE_TRACE ("ACE_WString::operator==");
  return this->len_ == s.len_
    && ACE_OS::memcmp ((const void *) this->rep_, (const void *) s.rep_,
		 this->len_ * sizeof (wchar_t)) == 0;
}

// Comparison operator.

INLINE int 
ACE_WString::operator!= (const ACE_WString &s) const
{
  ACE_TRACE ("ACE_WString::operator!=");
  return !(*this == s);
}
