/* -*- C++ -*- */

// ============================================================================
//
// = LIBRARY
//    ace
// 
// = FILENAME
//    Service_Object.h
//
// = AUTHOR
//    Doug Schmidt 
// 
// ============================================================================

#if !defined (ACE_SERVICE_OBJECT_H)
#define ACE_SERVICE_OBJECT_H

#include "ace/Shared_Object.h"
#include "ace/Event_Handler.h"
#include "ace/Log_Msg.h"

class ACE_Service_Object : public ACE_Event_Handler, public ACE_Shared_Object
  // = TITLE
  //     Provide the abstract base class common to all services 
{
public:
  // = Initialization and termination methods.
  ACE_Service_Object (void);
  virtual ~ACE_Service_Object (void);

  virtual int suspend (void);
    // Temporarily disable a service without removing it completely 
  virtual int resume (void);
    // Re-enable a previously suspended service 
};

#if defined (__INLINE__)
#include "ace/Service_Object.i"
#endif /* __INLINE__ */

#endif /* ACE_SERVICE_OBJECT_H */
