/* -*- C++ -*- */

/* Returns a count of the number of currently valid entries (counting
   both resumed and suspended entries). */

INLINE int
ACE_Service_Repository::current_size (void)
{
  ACE_TRACE ("ACE_Service_Repository::current_size");
  ACE_MT (ACE_Mutex_Guard m (this->lock_));
  return this->current_size_;
}

/* Returns a count of the total number of possible entries in the table. */

INLINE int
ACE_Service_Repository::total_size (void)
{
  ACE_TRACE ("ACE_Service_Repository::total_size");
  ACE_MT (ACE_Mutex_Guard m (this->lock_));
  return this->total_size_;
}

