/* -*- C++ -*- */

INLINE int 	       
ACE_Shared_Memory_MM::open (ACE_HANDLE handle, 
			    int length, 
			    int prot, 
			    int share, 
			    char *addr, 
			    off_t pos)
{
  ACE_TRACE ("ACE_Shared_Memory_MM::open");
  return shared_memory_.map (handle, length, prot, share, addr, pos);
}

INLINE int	   
ACE_Shared_Memory_MM::open (char file_name[], 
			    int len, 
			    int flags, 
			    int mode, 
			    int prot, 
			    int share, 
			    char *addr, 
			    off_t pos)
{
  ACE_TRACE ("ACE_Shared_Memory_MM::open");
  return shared_memory_.map (file_name, len, flags, mode, 
			     prot, share, addr, pos);
}

/* The overall size of the segment. */

INLINE int
ACE_Shared_Memory_MM::get_segment_size (void) const
{
  ACE_TRACE ("ACE_Shared_Memory_MM::get_segment_size");
  return this->shared_memory_.size ();
}

/* Unmaps the shared memory segment. */

INLINE int
ACE_Shared_Memory_MM::remove (void)
{
  ACE_TRACE ("ACE_Shared_Memory_MM::remove");
  return shared_memory_.unmap ();
}

/* Closes (unmaps) the shared memory segment. */

INLINE int
ACE_Shared_Memory_MM::close (void)
{
  ACE_TRACE ("ACE_Shared_Memory_MM::close");
  return shared_memory_.unmap ();
}

INLINE void *
ACE_Shared_Memory_MM::malloc (size_t)
{
  ACE_TRACE ("ACE_Shared_Memory_MM::malloc");
  void *addr;

  return this->shared_memory_ (addr) == -1 ? 0 : addr;
}

INLINE ACE_HANDLE
ACE_Shared_Memory_MM::get_id (void) const
{
  ACE_TRACE ("ACE_Shared_Memory_MM::get_id");
  return this->shared_memory_.handle ();
}

INLINE int  
ACE_Shared_Memory_MM::free (void *p)
{
  ACE_TRACE ("ACE_Shared_Memory_MM::free");
  return p != 0;
}
