#if !defined (ACE_SINGLETON_C)
#define ACE_SINGLETON_C

#include "ace/Singleton.h"

#if !defined (__INLINE__)
#include "ace/Singleton.i"
#endif /* __INLINE__ */

template <class TYPE, class LOCK> TYPE *
ACE_Singleton<TYPE, LOCK>::instance (void)
{
  ACE_TRACE ("ACE_Singleton::instance");

  // Perform the Double-Check pattern...
  if (ACE_Singleton<TYPE, LOCK>::instance_ == 0)
    {
      ACE_Guard<LOCK> lock (ACE_Singleton<TYPE, LOCK>::lock_);

      if (ACE_Singleton<TYPE, LOCK>::instance_ == 0)
	ACE_Singleton<TYPE, LOCK>::instance_ = new TYPE;
    }

  return ACE_Singleton<TYPE, LOCK>::instance_;
}

#endif
