/* -*- C++ -*- */

// = Set/get the length of the encoded/decoded message.
INLINE ACE_UINT32
ACE_Token_Request::length (void) const
{
  return this->transfer_.length_;
}

INLINE void 
ACE_Token_Request::length (ACE_UINT32 l)
{
  this->transfer_.length_ = l;
}

// = Set/get the type of the message.
INLINE ACE_Tokens::TOKEN_TYPE 
ACE_Token_Request::token_type (void) const
{
  return (ACE_Tokens::TOKEN_TYPE) this->transfer_.token_type_;
}

INLINE void 
ACE_Token_Request::token_type (ACE_Tokens::TOKEN_TYPE t)
{
  this->transfer_.token_type_ = (ACE_UINT32) t;
}

// = Set/get the type of the message.
INLINE ACE_Token_Proxy::PROXY_TYPE 
ACE_Token_Request::proxy_type (void) const
{
  return (ACE_Token_Proxy::PROXY_TYPE) this->transfer_.proxy_type_;
}

INLINE void 
ACE_Token_Request::proxy_type (ACE_Token_Proxy::PROXY_TYPE t)
{
  this->transfer_.proxy_type_ = (ACE_UINT32) t;
}

// = Set/get the type of the message.
INLINE ACE_UINT32
ACE_Token_Request::operation_type (void) const
{
  return this->transfer_.operation_type_;
}

INLINE void 
ACE_Token_Request::operation_type (ACE_UINT32 t)
{
  this->transfer_.operation_type_ = t;
}

// = Set/get the requeue position
INLINE ACE_UINT32 
ACE_Token_Request::requeue_position (void) const
{
  return this->transfer_.requeue_position_;
}

INLINE void 
ACE_Token_Request::requeue_position (ACE_UINT32 rq)
{
  this->transfer_.requeue_position_ = rq;
}

// = Set/get the requeue position
INLINE ACE_UINT32 
ACE_Token_Request::notify (void) const
{
  return this->transfer_.notify_;
}

INLINE void 
ACE_Token_Request::notify (ACE_UINT32 rq)
{
  this->transfer_.notify_ = rq;
}

// = Set/get the blocking semantics.
INLINE ACE_Synch_Options &
ACE_Token_Request::options (void) const
{
  return (ACE_Synch_Options &) options_;
}

INLINE void 
ACE_Token_Request::options (const ACE_Synch_Options &opt)
{
  // fight the friggin const from hell
  ACE_Synch_Options *options = (ACE_Synch_Options *) &opt;

  transfer_.use_timeout_ = options->operator[](ACE_Synch_Options::USE_TIMEOUT);
  if (transfer_.use_timeout_ == 1)
    {
      transfer_.usec_ = options->timeout ().usec ();
      transfer_.sec_ = options->timeout ().sec ();
    }
  else
    {
      transfer_.usec_ = 0;
      transfer_.sec_ = 0;
    }
}

// = Set/get the name of the token.
INLINE char *
ACE_Token_Request::token_name (void) const
{
  return token_name_;
}

INLINE void 
ACE_Token_Request::token_name (const char *token_name, const char *client_id)
{
  size_t token_name_length = ACE_OS::strlen (token_name) + 1; // Add 1 for '\0'.
  size_t client_id_length  = ACE_OS::strlen (client_id) + 1; // Add 1 for '\0'.

  // Set up pointers and copy token_name and client_id into request.
  token_name_ = this->transfer_.data_;
  client_id_  = &this->token_name_[token_name_length + 1]; // Add 1 for ':';
  client_id_[-1] = ':'; // Insert the ':' before this->clientId_.

  (void) ACE_OS::memcpy (token_name_, token_name, token_name_length);
  (void) ACE_OS::memcpy (client_id_, client_id, client_id_length);

  // Compute size of the fixed portion of the message...
  size_t len = sizeof this->transfer_ - sizeof this->transfer_.data_;
  
  // ... then add in the amount of the variable-sized portion. 
  len += token_name_length + client_id_length + 1;

  this->length (len);
}

// = Set/get the id of the client.
INLINE char *
ACE_Token_Request::client_id (void) const
{
  return this->client_id_;
}

// ************************************************************
// ************************************************************
// ************************************************************

// = Set/get the length of the encoded/decoded message.
INLINE ACE_UINT32 
ACE_Token_Reply::length (void) const
{
  return this->transfer_.length_;
}

INLINE void 
ACE_Token_Reply::length (ACE_UINT32 l)
{
  this->transfer_.length_ = l;
}

// = Set/get the errno of a failed reply.
INLINE ACE_UINT32 
ACE_Token_Reply::errnum (void) const
{
  return this->transfer_.errno_;
}

INLINE void 
ACE_Token_Reply::errnum (ACE_UINT32 e)
{
  this->transfer_.errno_ = e;
}

// = Set/get the length of the encoded/decoded message.
INLINE ACE_UINT32 
ACE_Token_Reply::arg (void) const
{
  return this->transfer_.arg_;
}

INLINE void 
ACE_Token_Reply::arg (ACE_UINT32 arg)
{
  this->transfer_.arg_ = arg;
}

