/* -*- C++ -*- */

template <class T> INLINE
ACE_Typed_SV_Message<T>::ACE_Typed_SV_Message (long t, 
					       int l, 
					       int m)
  : type_ (t),
    length_ (l),
    max_ (m)
{
  ACE_TRACE ("ACE_Typed_SV_Message<T>::ACE_Typed_SV_Message");
}

template <class T> INLINE
ACE_Typed_SV_Message<T>::ACE_Typed_SV_Message (const T &d, 
					       long t, 
					       int l, 
					       int m)
  : data_ (d),
    type_ (t),
    length_ (l),
    max_ (m)
{
  ACE_TRACE ("ACE_Typed_SV_Message<T>::ACE_Typed_SV_Message");
}

template <class T> INLINE
ACE_Typed_SV_Message<T>::~ACE_Typed_SV_Message (void)
{
  ACE_TRACE ("ACE_Typed_SV_Message<T>::~ACE_Typed_SV_Message");
}

template <class T> INLINE long
ACE_Typed_SV_Message<T>::type (void) const
{
  ACE_TRACE ("ACE_Typed_SV_Message<T>::type");
  return this->type_;
}

template <class T> INLINE void
ACE_Typed_SV_Message<T>::type (long t)
{
  ACE_TRACE ("ACE_Typed_SV_Message<T>::type");
  this->type_ = t;
}

template <class T> INLINE int
ACE_Typed_SV_Message<T>::length (void) const
{
  ACE_TRACE ("ACE_Typed_SV_Message<T>::length");
  return this->length_;
}

template <class T> INLINE void
ACE_Typed_SV_Message<T>::length (int l)
{
  ACE_TRACE ("ACE_Typed_SV_Message<T>::length");
  this->length_ = 1 + (sizeof *this - (sizeof this->type_ + sizeof this->data_));
}

template <class T> INLINE int
ACE_Typed_SV_Message<T>::max_size (void) const
{
  ACE_TRACE ("ACE_Typed_SV_Message<T>::max_size");
  return this->max_;
}

template <class T> INLINE void
ACE_Typed_SV_Message<T>::max_size (int m)
{
  ACE_TRACE ("ACE_Typed_SV_Message<T>::max_size");
  this->max_ = m + (sizeof *this - (sizeof this->type_ + sizeof this->data_));
}

template <class T> T &
ACE_Typed_SV_Message<T>::data (void)
{
  ACE_TRACE ("ACE_Typed_SV_Message<T>::data");
  return this->data_;
}

template <class T> void
ACE_Typed_SV_Message<T>::data (const T &d)
{
  ACE_TRACE ("ACE_Typed_SV_Message<T>::data");
  this->data_ = d;
}

