/* -*- C++ -*- */
/* Defines the classes that handle the client logging daemon. */

// ============================================================================
//
// = LIBRARY
//    ace
// 
// = FILENAME
//    Client_Logger.h 
//
// = AUTHOR
//    Doug Schmidt 
// 
// ============================================================================

#include "ace/SOCK_Stream.h"
#include "ace/FIFO_Recv_Msg.h"
#include "ace/Log_Record.h"

#if !defined (_CLIENT_LOGGER_H)
#define _CLIENT_LOGGER_H

class Client_Logger
  // = TITLE
  //
  //
  // = DESCRIPTION
  //
{
public:
  Client_Logger (void);
  Client_Logger (unsigned short remote_port, const char *remote_host, char *logger_key);
  int open (unsigned short remote_port, const char *remote_host, char *logger_key);
  int recv (void);
  int send (void);
  int remove (void);

private:
  ACE_FIFO_Recv_Msg      message_queue_;
  ACE_Log_Record	     log_record_;
  static ACE_SOCK_Stream logger_output_;

  static void stderr_output (int = 0);
};

#if defined (__INLINE__)
#define INLINE inline
#include "Client_Logger.i"
#else 
#define INLINE
#endif /* __INLINE__ */
#endif /* _CLIENT_LOGGER_H */
