#include "ace/Log_Msg.h"
#include "Client_Acceptor.h"
#include "Client_Handler.h"

#if !defined (__INLINE__)
#include "Client_Acceptor.i"
#endif /* __INLINE__ */

// Initialize peer_acceptor object.

int
Client_Acceptor::open (const ACE_INET_Addr &addr)
{
  // Reuse addr if already in use.
  if (this->peer_acceptor_.open (addr, 1) == -1)
    return -1;
  else
    return 0;
}

/* Default constructor */

Client_Acceptor::Client_Acceptor (ACE_Reactor &r)
  : reactor_ (r)
{
}

/* Performs termination activities */

int
Client_Acceptor::handle_close (int, ACE_Reactor_Mask)
{
  return this->peer_acceptor_.close ();
}

Client_Acceptor::~Client_Acceptor (void)
{
  this->handle_close (-1, ACE_Event_Handler::READ_MASK);
}

/* Returns underlying device descriptor */

int
Client_Acceptor::get_handle (void) const
{ 
  return this->peer_acceptor_.get_handle (); 
}

// Accepts connections from client and registers new object with the
// ACE_Reactor.

int
Client_Acceptor::handle_input (int) 
{
  Client_Handler *svc_handler = new Client_Handler;

  // Accept the connection from a client client daemon.

  if (this->peer_acceptor_.accept (*svc_handler) == -1)
    ACE_ERROR_RETURN ((LM_ERROR, "%p", "accept failed"), -1);
  else if (svc_handler->open (&this->reactor_) == -1)
    svc_handler->close ();

  return 0;
}
