/* -*- C++ -*- */

// ============================================================================
//
// = LIBRARY
//    ace
// 
// = FILENAME
//    Client_Acceptor.h 
//
// = AUTHOR
//    Doug Schmidt 
// 
// ============================================================================

#if !defined (_CLIENT_ACCEPTOR_H)
#define _CLIENT_ACCEPTOR_H

#include "ace/Reactor.h"
#include "ace/SOCK_Acceptor.h"

class Client_Acceptor : public ACE_Event_Handler
  // = TITLE
  //     Handle connection requests from remote client clients. 
  //
  // = DESCRIPTION
  //     Accepts client connection requests and registeres them with
  //     the ACE_Reactor.
{
friend class Client_Handler;
public:
  Client_Acceptor (ACE_Reactor &r);
  ~Client_Acceptor (void);

  int open (const ACE_INET_Addr &a);

private:
  virtual int get_handle (void) const;
  virtual int handle_input (ACE_HANDLE);
  virtual int handle_close (ACE_HANDLE, ACE_Reactor_Mask);

  ACE_SOCK_Acceptor peer_acceptor_;     
  // Passive connection acceptor factory.

  ACE_Reactor &reactor_;
};

#if defined (__INLINE__)
#define INLINE inline
#include "Client_Acceptor.i"
#else 
#define INLINE
#endif /* __INLINE__ */
#endif /* _CLIENT_ACCEPTOR_H */
