// ============================================================================
//
// = LIBRARY
//    ace
// 
// = FILENAME
//    Client_Handler.h 
//
// = AUTHOR
//    Doug Schmidt 
// 
// ============================================================================

#if !defined (_CLIENT_HANDLER_H)
#define _CLIENT_HANDLER_H

#include "ace/Event_Handler.h"
#include "ace/INET_Addr.h"
#include "ace/SOCK_Stream.h"

class Client_Handler : public ACE_Event_Handler
  // = TITLE
  //     Receive client message from the remote clients. 
{
public:
  Client_Handler (void);  

  // = Hooks for opening and closing handlers.
  virtual int open (void *);
  virtual int close (void);

  operator ACE_SOCK_Stream &();

protected:
  // = Demultiplexing hooks.
  virtual int get_handle (void) const;
  virtual int handle_input (int);
  virtual int handle_close (int, ACE_Reactor_Mask);

  char host_name_[MAXHOSTNAMELEN + 1];
  // Host we are connected to.

  ACE_SOCK_Stream cli_stream_; 
  // Connection with client 

  // = Really should be private...
  virtual ~Client_Handler (void); 
  // Ensure dynamic allocation.
};

#if defined (__INLINE__)
#define INLINE inline
#include "Client_Handler.i"
#else 
#define INLINE
#endif /* __INLINE__ */
#endif /* _CLIENT_HANDLER_H */
