/* This server daemon collects, formats, and displays logging
   information forwarded from client daemons running on other hosts in
   the network. 

   In addition, it also illustrates how the Service Configurator framework
   is used.  Note in particular how this driver file is completely generic 
   and may be used to configure almost any type of daemon. */

#include "ace/Service_Config.h"

int
main (int argc, char *argv[])
{
  ACE_Service_Config daemon;

  if (daemon.open (argc, argv) == -1)
    ACE_ERROR_RETURN ((LM_ERROR, "%p\n", "open"), 1);

  // Run forever, performing the configured 
  // services until we receive a SIGINT.

  daemon.run_event_loop ();
  return 0;
}
