
#ifndef Event_Comm_hh
#define Event_Comm_hh

#include <CORBA.h>

#include <string.h>

class Event_Comm {
public: 

#ifndef Event_Comm_Notification_defined
#define Event_Comm_Notification_defined

    struct IONANC_Notification;
    struct Notification {
        char * tag_;

        void encodeOp (CORBA::Request &IT_r) const;
        void decodeOp (CORBA::Request &IT_r);
        void decodeInOutOp (CORBA::Request &IT_r);
        static void* IT_anySupport (CORBA::Request &IT_r,
        			void *&, void*, const CORBA::Flags&);
        static const void *IT_fn;
        Notification(const Notification &);
        Notification();
        operator Event_Comm::IONANC_Notification();
        operator const Event_Comm::IONANC_Notification() const;
        Notification& operator= (const IONANC_Notification&);
        ~Notification();
        Notification& operator= (const Notification&);
    };


#define TC_Event_Comm_Notification "\
R~Event_Comm::Notification~tag_{0}\
"

    struct IONANC_Notification {
        char * tag_;
        operator Event_Comm::Notification ();
        operator const Event_Comm::Notification () const;
        };


#endif


#ifndef _Event_Comm_Notification_Receiver_defined
#define _Event_Comm_Notification_Receiver_defined
class Notification_Receiver_dispatch : public virtual CORBA::PPTR {
public:

   Notification_Receiver_dispatch (void *IT_p, CORBA::Object* IT_o, const char *IT_m, 
        CORBA::LoaderClass *IT_l, char *IT_i, void* IT_im)
       : CORBA::PPTR (IT_p,IT_o,IT_m,IT_l,IT_i,IT_im) {}


   Notification_Receiver_dispatch (char *IT_OR, void *IT_p, CORBA::Object *IT_o)
       : CORBA::PPTR (IT_OR,IT_p,IT_o) {}


   Notification_Receiver_dispatch () {}

   Notification_Receiver_dispatch (void *IT_p, CORBA::Object *IT_o, const char *IT_m, 
        char *IT_i, CORBA::Object* IT_ob, void* IT_im)
       : CORBA::PPTR (IT_p,IT_o,IT_m,IT_i,IT_ob,IT_im) {}


   virtual unsigned char dispatch (CORBA::Request &IT_r, 
        unsigned char IT_isTarget, void* IT_pp=NULL);


};

class Notification_Receiver;


#ifndef Event_Comm_Notification_ReceiverForwH
#define Event_Comm_Notification_ReceiverForwH
static CORBA::ObjectRef Notification_Receiver_getBase (void *);
static void Notification_Receiver_release (void *, CORBA::Environment &IT_env=CORBA::default_environment);
static Notification_Receiver* Notification_Receiver_duplicate (void *, CORBA::Environment &IT_env=CORBA::default_environment);
#endif
#define Event_Comm_Notification_Receiver_IMPL "Event_Comm_Notification_Receiver"


class Notification_Receiver;
#define Event_Comm_Notification_Receiver_IR "Event_Comm_Notification_Receiver"
#define Event_Comm_Notification_Receiver_IMPL "Event_Comm_Notification_Receiver"

typedef Notification_Receiver* Notification_ReceiverRef;
typedef Notification_Receiver* Notification_Receiver_ptr;
class Notification_Receiver: public virtual CORBA::Object {
public:
    Notification_Receiver (char *IT_OR);
    Notification_Receiver () : CORBA::Object (1) {}
    Notification_Receiver* _duplicate(
            CORBA::Environment &IT_env=CORBA::default_environment) {
       CORBA::Object::_duplicate (IT_env); return this; }
   static Notification_Receiver* _bind (const char* IT_markerServer, const char* host,
		const CORBA::Context &IT_c, 
		CORBA::Environment &IT_env=CORBA::default_environment);
   static Notification_Receiver* _bind (CORBA::Environment &IT_env);
   static Notification_Receiver* _bind (const char* IT_markerServer=NULL, const char* host=NULL,
                 CORBA::Environment &IT_env=CORBA::default_environment);
    static Notification_Receiver* _narrow (CORBA::Object* , CORBA::Environment &IT_env=CORBA::default_environment);
        	virtual void receive_notification (const Event_Comm::Notification& notification, CORBA::Environment &IT_env=CORBA::default_environment);
        	virtual void disconnect (const char * reason, CORBA::Environment &IT_env=CORBA::default_environment);
};

#define TC_Event_Comm_Notification_Receiver "\
R~Event_Comm::Notification_Receiver~receive_notification{Ro~receive_notification~+notification{R~Event_Comm::Notification~tag_{0}},>{v},O{}},disconnect{Ro~disconnect~+reason{0},>{v},O{}}\
"

#define TC_Event_Comm_Notification_ReceiverRef "\
O~Event_Comm::Notification_Receiver\
"


#define TIE_Event_Comm_Notification_Receiver(X) Event_Comm_Notification_Receiver##X

#define DEF_TIE_Event_Comm_Notification_Receiver(X) \
	class Event_Comm_Notification_Receiver##X : public virtual Event_Comm::Notification_Receiver {		\
	  X* m_obj;						\
	public:							\
								\
	   Event_Comm_Notification_Receiver##X  (X *objp, const char* m="", CORBA::LoaderClass *l=nil)\
		: Event_Comm::Notification_Receiver(), CORBA::Object (), m_obj(objp) {	\
		m_pptr = new Event_Comm::Notification_Receiver_dispatch		\
			(( Event_Comm::Notification_Receiver*)this,(CORBA::Object*)this,m,l,Event_Comm_Notification_Receiver_IR,m_obj);	\
	   }								\
	   Event_Comm_Notification_Receiver##X  (CORBA::Object *IT_p, const char* IT_m="", void *IT_q=nil)\
		: Event_Comm::Notification_Receiver(), CORBA::Object () {	\
		m_pptr = new Event_Comm::Notification_Receiver_dispatch		\
			(( Event_Comm::Notification_Receiver*)this,(CORBA::Object*)this,IT_m,Event_Comm_Notification_Receiver_IR,IT_p,IT_q);	\
		m_obj = (X*)(m_pptr->getImplObj ());			\
	   }								\
								\
	   virtual ~Event_Comm_Notification_Receiver##X  () {				\
		if (_okToDeleteImpl ()) delete m_obj; }					\
								\
	   virtual void* _deref () {					\
		return m_obj; }					\
								\
    	virtual void receive_notification (const Event_Comm::Notification& notification, CORBA::Environment &IT_env) {\
    m_obj->receive_notification ( notification,IT_env);\
}\
	\
    	virtual void disconnect (const char * reason, CORBA::Environment &IT_env) {\
    m_obj->disconnect ( reason,IT_env);\
}\
								\
	};


#define QUALS_Event_Comm_Notification_Receiver	\
    	virtual void receive_notification (const Event_Comm::Notification& notification, CORBA::Environment &IT_env) {\
    m_obj->receive_notification ( notification,IT_env);\
}\
	\
    	virtual void disconnect (const char * reason, CORBA::Environment &IT_env) {\
    m_obj->disconnect ( reason,IT_env);\
}\




class Notification_ReceiverProxyFactoryClass : public virtual CORBA::ObjectFactoryClass {
public:
   Notification_ReceiverProxyFactoryClass (unsigned char IT_p=0)
		: CORBA::ProxyFactory (Event_Comm_Notification_Receiver_IR, IT_p) {}

    virtual void* New (char *IT_OR, CORBA::Environment&);

    virtual void* New2 (); 

    virtual void* IT_castUp (void *IT_p, char* IT_s);

    virtual CORBA::PPTR* pptr (void *IT_p);

    virtual void baseInterfaces (_IDL_SEQUENCE_string&);


};

static Notification_ReceiverProxyFactoryClass Notification_ReceiverProxyFactory;



#endif


#ifndef _Event_Comm_Notifier_defined
#define _Event_Comm_Notifier_defined
class Notifier_dispatch : public virtual CORBA::PPTR {
public:

   Notifier_dispatch (void *IT_p, CORBA::Object* IT_o, const char *IT_m, 
        CORBA::LoaderClass *IT_l, char *IT_i, void* IT_im)
       : CORBA::PPTR (IT_p,IT_o,IT_m,IT_l,IT_i,IT_im) {}


   Notifier_dispatch (char *IT_OR, void *IT_p, CORBA::Object *IT_o)
       : CORBA::PPTR (IT_OR,IT_p,IT_o) {}


   Notifier_dispatch () {}

   Notifier_dispatch (void *IT_p, CORBA::Object *IT_o, const char *IT_m, 
        char *IT_i, CORBA::Object* IT_ob, void* IT_im)
       : CORBA::PPTR (IT_p,IT_o,IT_m,IT_i,IT_ob,IT_im) {}


   virtual unsigned char dispatch (CORBA::Request &IT_r, 
        unsigned char IT_isTarget, void* IT_pp=NULL);


};

class Notifier;


#ifndef Event_Comm_NotifierForwH
#define Event_Comm_NotifierForwH
static CORBA::ObjectRef Notifier_getBase (void *);
static void Notifier_release (void *, CORBA::Environment &IT_env=CORBA::default_environment);
static Notifier* Notifier_duplicate (void *, CORBA::Environment &IT_env=CORBA::default_environment);
#endif
#define Event_Comm_Notifier_IMPL "Event_Comm_Notifier"


class Notifier;
#define Event_Comm_Notifier_IR "Event_Comm_Notifier"
#define Event_Comm_Notifier_IMPL "Event_Comm_Notifier"

typedef Notifier* NotifierRef;
typedef Notifier* Notifier_ptr;
class Notifier: public virtual CORBA::Object {
public:
    Notifier (char *IT_OR);
    Notifier () : CORBA::Object (1) {}
    Notifier* _duplicate(
            CORBA::Environment &IT_env=CORBA::default_environment) {
       CORBA::Object::_duplicate (IT_env); return this; }
   static Notifier* _bind (const char* IT_markerServer, const char* host,
		const CORBA::Context &IT_c, 
		CORBA::Environment &IT_env=CORBA::default_environment);
   static Notifier* _bind (CORBA::Environment &IT_env);
   static Notifier* _bind (const char* IT_markerServer=NULL, const char* host=NULL,
                 CORBA::Environment &IT_env=CORBA::default_environment);
    static Notifier* _narrow (CORBA::Object* , CORBA::Environment &IT_env=CORBA::default_environment);
        	virtual void send_disconnect (const char * reason, CORBA::Environment &IT_env=CORBA::default_environment);
        	virtual void send_notification (const Event_Comm::Notification& notification, CORBA::Environment &IT_env=CORBA::default_environment);
        	virtual void subscribe (Event_Comm::Notification_Receiver* notification_receiver, const char * filtering_criteria, CORBA::Environment &IT_env=CORBA::default_environment);
        	virtual void unsubscribe (Event_Comm::Notification_Receiver* notification_receiver, const char * filtering_criteria, CORBA::Environment &IT_env=CORBA::default_environment);
};

#define TC_Event_Comm_Notifier "\
R~Event_Comm::Notifier~send_disconnect{Ro~send_disconnect~+reason{0},>{v},O{}},send_notification{Ro~send_notification~+notification{R~Event_Comm::Notification~tag_{0}},>{v},O{}},subscribe{Ro~subscribe~+notification_receiver{O~Event_Comm::Notification_Rec\
eiver},+filtering_criteria{0},>{v},O{}},unsubscribe{Ro~unsubscribe~+notification_receiver{O~Event_Comm::Notification_Receiver},+filtering_criteria{0},>{v},O{}}\
"

#define TC_Event_Comm_NotifierRef "\
O~Event_Comm::Notifier\
"


#define TIE_Event_Comm_Notifier(X) Event_Comm_Notifier##X

#define DEF_TIE_Event_Comm_Notifier(X) \
	class Event_Comm_Notifier##X : public virtual Event_Comm::Notifier {		\
	  X* m_obj;						\
	public:							\
								\
	   Event_Comm_Notifier##X  (X *objp, const char* m="", CORBA::LoaderClass *l=nil)\
		: Event_Comm::Notifier(), CORBA::Object (), m_obj(objp) {	\
		m_pptr = new Event_Comm::Notifier_dispatch		\
			(( Event_Comm::Notifier*)this,(CORBA::Object*)this,m,l,Event_Comm_Notifier_IR,m_obj);	\
	   }								\
	   Event_Comm_Notifier##X  (CORBA::Object *IT_p, const char* IT_m="", void *IT_q=nil)\
		: Event_Comm::Notifier(), CORBA::Object () {	\
		m_pptr = new Event_Comm::Notifier_dispatch		\
			(( Event_Comm::Notifier*)this,(CORBA::Object*)this,IT_m,Event_Comm_Notifier_IR,IT_p,IT_q);	\
		m_obj = (X*)(m_pptr->getImplObj ());			\
	   }								\
								\
	   virtual ~Event_Comm_Notifier##X  () {				\
		if (_okToDeleteImpl ()) delete m_obj; }					\
								\
	   virtual void* _deref () {					\
		return m_obj; }					\
								\
    	virtual void send_disconnect (const char * reason, CORBA::Environment &IT_env) {\
    m_obj->send_disconnect ( reason,IT_env);\
}\
	\
    	virtual void send_notification (const Event_Comm::Notification& notification, CORBA::Environment &IT_env) {\
    m_obj->send_notification ( notification,IT_env);\
}\
	\
    	virtual void subscribe (Event_Comm::Notification_Receiver* notification_receiver, const char * filtering_criteria, CORBA::Environment &IT_env) {\
    m_obj->subscribe ( notification_receiver, filtering_criteria,IT_env);\
}\
	\
    	virtual void unsubscribe (Event_Comm::Notification_Receiver* notification_receiver, const char * filtering_criteria, CORBA::Environment &IT_env) {\
    m_obj->unsubscribe ( notification_receiver, filtering_criteria,IT_env);\
}\
								\
	};


#define QUALS_Event_Comm_Notifier	\
    	virtual void send_disconnect (const char * reason, CORBA::Environment &IT_env) {\
    m_obj->send_disconnect ( reason,IT_env);\
}\
	\
    	virtual void send_notification (const Event_Comm::Notification& notification, CORBA::Environment &IT_env) {\
    m_obj->send_notification ( notification,IT_env);\
}\
	\
    	virtual void subscribe (Event_Comm::Notification_Receiver* notification_receiver, const char * filtering_criteria, CORBA::Environment &IT_env) {\
    m_obj->subscribe ( notification_receiver, filtering_criteria,IT_env);\
}\
	\
    	virtual void unsubscribe (Event_Comm::Notification_Receiver* notification_receiver, const char * filtering_criteria, CORBA::Environment &IT_env) {\
    m_obj->unsubscribe ( notification_receiver, filtering_criteria,IT_env);\
}\




class NotifierProxyFactoryClass : public virtual CORBA::ObjectFactoryClass {
public:
   NotifierProxyFactoryClass (unsigned char IT_p=0)
		: CORBA::ProxyFactory (Event_Comm_Notifier_IR, IT_p) {}

    virtual void* New (char *IT_OR, CORBA::Environment&);

    virtual void* New2 (); 

    virtual void* IT_castUp (void *IT_p, char* IT_s);

    virtual CORBA::PPTR* pptr (void *IT_p);

    virtual void baseInterfaces (_IDL_SEQUENCE_string&);


};

static NotifierProxyFactoryClass NotifierProxyFactory;



#endif

};


#endif
