#include "ace/Synch.h"
#include "Options.h"
#include "Benchmark.h"

#if defined (ACE_HAS_THREADS)

class Cond_Signal_Test : public Benchmark
{
public:
  virtual int svc (void);

private:
  static ACE_Mutex mutex;
  static int resources;

  static ACE_Condition_Mutex notfull;
  static ACE_Condition_Mutex notempty;
};

ACE_Mutex Cond_Signal_Test::mutex;
int Cond_Signal_Test::resources;
ACE_Condition_Mutex Cond_Signal_Test::notfull (Cond_Signal_Test::mutex);
ACE_Condition_Mutex Cond_Signal_Test::notempty (Cond_Signal_Test::mutex);

int
Cond_Signal_Test::svc (void)
{
  int ni = this->thr_id ();
  synch_count = 2;

  if (ni == 4)
    while (!this->done ())
      {
	mutex.acquire ();
	while (resources > 0)
	  notfull.wait ();
	options.thr_work_count[ni]++;
	resources = options.thr_count () - 1;
	buffer++;
	notempty.signal ();
	mutex.release ();
      }
  else
    while (!this->done ())
      {
	mutex.acquire ();
	while (resources == 0)
	  notempty.wait ();
	options.thr_work_count[ni]++;
	buffer++;
	if (--resources == 0)
	  notfull.signal ();
	mutex.release ();
      }

  /* NOTREACHED */
  return 0;
}

Cond_Signal_Test cond_signal_test;
ACE_Service_Object_Type cst (&cond_signal_test, "Condition_Signal_Test");
#endif /* ACE_HAS_THREADS */
