

#include "TS_Mutex.h"
#include "ace/Log_Msg.h"

#if !defined (__INLINE__)
#include "TS_Mutex.i"
#endif /* __INLINE__ */

ACE_TS_Mutex::ACE_TS_Mutex (const char *token_name,
			    int debug,
			    Token_Handler* th,
			    ACE_Token_Proxy::PROXY_TYPE proxy_type,
			    ACE_Tokens::TOKEN_TYPE token_type)
: ACE_Token_Proxy (token_name, 0, debug, proxy_type, token_type),
  th_ (th)
{
  ACE_TRACE ("ACE_TS_Mutex::ACE_TS_Mutex");
}

ACE_TS_Mutex::ACE_TS_Mutex (const ACE_TS_Mutex &rhs)
: ACE_Token_Proxy (rhs),
  th_ (rhs.th_)
{
}


ACE_TS_Mutex::~ACE_TS_Mutex ()
{
  ACE_TRACE ("ACE_TS_Mutex::~ACE_TS_Mutex");
}

void 
ACE_TS_Mutex::sleep_hook ()
{
  ACE_TRACE ("ACE_TS_Mutex::sleep_hook");
  th_->sleep_hook ();
  return;
}

void 
ACE_TS_Mutex::token_acquired (void *arg)
{
  ACE_TRACE ("ACE_TS_Mutex::token_acquired");
  th_->token_acquired (arg);
  return;
}

ACE_Token_Proxy *
ACE_TS_Mutex::clone (void)
{
  ACE_TRACE ("ACE_TS_Mutex::clone");
  return new ACE_TS_Mutex (*this);
}

