
/* -*- C++ -*- */

// ============================================================================
//
// = LIBRARY
//    ace
// 
// = FILENAME
//    TS_Mutex
//
// = AUTHOR
//    Tim Harrison (harrison@cs.wustl.edu)
// 
// ============================================================================

#if !defined (ACE_TS_Mutex_H)
#define ACE_TS_Mutex_H

#include "ace/Local_Tokens.h"
#include "Token_Handler.h"

class Token_Handler;

class ACE_TS_Mutex : public ACE_Token_Proxy
  // = TITLE
  //
  // = DESCRIPTION 
{
public:
  // = Initialization and termination.

  ACE_TS_Mutex (const char *token_name,
		int debug,
		Token_Handler* th,
		ACE_Token_Proxy::PROXY_TYPE lock_type,
		ACE_Tokens::TOKEN_TYPE token_type);

  ACE_TS_Mutex (const ACE_TS_Mutex &rhs);
  // copy me.

  ~ACE_TS_Mutex (void);
  // death

  virtual void sleep_hook (void);
  // Somebody wants our token!  (Let'em wait...)

  virtual void token_acquired (void *arg);
  // We've been taken off the waiters list and given the token!

  virtual ACE_Token_Proxy *clone (void);

private:
  Token_Handler* th_;
};

#if defined (__INLINE__)
#define INLINE inline
#include "TS_Mutex.i"
#else
#define INLINE
#endif /* __INLINE__ */

#endif /* ACE_TS_Mutex_H */
