#include "ace/Stream.h"
#include "ace/Task.h"
#include "ace/Module.h"

#if defined (ACE_HAS_THREADS)
typedef ACE_Task<ACE_MT_SYNCH> MT_Task;
typedef ACE_Stream<ACE_MT_SYNCH> MT_Stream;
typedef ACE_Module<ACE_MT_SYNCH> MT_Module;
#else
typedef ACE_Task<ACE_NULL_SYNCH> MT_Task;
typedef ACE_Stream<ACE_NULL_SYNCH> MT_Stream;
typedef ACE_Module<ACE_NULL_SYNCH> MT_Module;
#endif /* ACE_HAS_THREADS */

#if defined (ACE_HAS_SVR4_DYNAMIC_LINKING)
class Test_Task : public MT_Task
{
public:
  virtual int open (void *);
  virtual int close (u_long);
  virtual int put (ACE_Message_Block *, ACE_Time_Value * = 0);
  virtual int svc (void);
  virtual int info (char **, size_t) const;
  virtual int init (int, char **);
  virtual int fini (void);
  virtual int suspend (void);
  virtual int resume (void);
};

int 
Test_Task::open (void *)
{ 
  ACE_DEBUG ((LM_DEBUG, "opening %s\n", this->name ())); 
  return 0;
}

int 
Test_Task::close (u_long) 
{
  ACE_DEBUG ((LM_DEBUG, "closing %s\n", this->name ()));
  return 0;
}

int 
Test_Task::suspend (void) 
{ 
  ACE_DEBUG ((LM_DEBUG, "suspending in %s\n", this->name ())); 
  return 0; 
}

int 
Test_Task::resume (void) 
{
  ACE_DEBUG ((LM_DEBUG, "resuming in %s\n", this->name ()));
  return 0;
}

int 
Test_Task::put (ACE_Message_Block *, ACE_Time_Value *)
{
  return 0;
}

int 
Test_Task::svc (void)
{
  return 0;
}

int
Test_Task::info (char **, size_t) const
{
  return 0;
}

int 
Test_Task::init (int, char **)
{
  ACE_DEBUG ((LM_DEBUG, "initializing %s\n", this->name ()));
  return 0; 
}

int 
Test_Task::fini (void)
{
  ACE_DEBUG ((LM_DEBUG, "finalizing %s\n", this->name ()));
  return 0; 
}

/* Dynamically linked functions used to control configuration */

extern "C" MT_Stream *_alloc (void);
extern "C" MT_Module *_alloc_da (void);
extern "C" MT_Module *_alloc_ea (void);
extern "C" MT_Module *_alloc_mr (void);

MT_Stream *
_alloc (void)
{
  return new MT_Stream;
}

MT_Module *
_alloc_da (void)
{
  return new MT_Module ("Device_Adapter", new Test_Task, new Test_Task);
}

MT_Module *
_alloc_ea (void)
{
  return new MT_Module ("Event_Analyzer", new Test_Task, new Test_Task);
}

MT_Module *
_alloc_mr (void)
{
  return new MT_Module ("Multicast_Router", new Test_Task, new Test_Task);
}
#endif /* ACE_HAS_SVR4_DYNAMIC_LINKING */
