#include "ace/Log_Msg.h"
#include "ace/OS.h"
#include "ace/DEV_Addr.h"
#include "ace/DEV_Connector.h"
#include "ace/DEV_IO.h"
#include <iostream.h>

#include "tty_io.h"
int 
main (int argc, char *argv[])
{
#if defined (ACE_HAS_TERM_IOCTLS)
  if (argc < 2)
    ACE_ERROR_RETURN ((LM_ERROR, "usage: %s device-filename\n", argv[0]), 1);

  char writeto = 'x';
  TTY_IO write_dev;

  ACE_DEV_Connector con;

  if (con.connect (write_dev, ACE_DEV_Addr (argv[1])) == -1)
    ACE_ERROR_RETURN ((LM_ERROR, "%p\n", argv[1]), 1);

  int bytes_written;

  struct TTY_IO::Serial_Params myparams;
  myparams.baudrate = 9600;
  myparams.parityenb = 1;
  myparams.paritymode = "EVEN";
  myparams.databits = 8;
  myparams.stopbits = 1;
  myparams.readtimeoutmsec = 200;
  myparams.ctsenb = 0;
  myparams.rcvenb = 1;

  int ret = write_dev.control(TTY_IO::SETPARAMS, &myparams);

  if (ret == -1)
    ACE_ERROR_RETURN ((LM_ERROR, "%p\n", "control"), 1);

  cout << "enter character to send, q terminates :" << endl;
  while (ACE_OS::read(0,&writeto,1) != -1)
    {
    bytes_written = write_dev.send_n ((void *)&writeto, 1);
    if (bytes_written != 1)
      ACE_ERROR_RETURN ((LM_ERROR, "%p\n", "send"), 1);
    if (writeto == 'q')
      break;
    }
  if (write_dev.close () == -1)
    ACE_ERROR_RETURN ((LM_ERROR, "%p\n", "close"), 1);


  return 0;
#else
  ACE_ERROR_RETURN ((LM_ERROR, "this platform doesn't support term ioctls\n"), -1);
#endif /* ACE_HAS_TERM_IOCTLS */
}
