// Test the Log_Msg abstraction.

#include "ace/Log_Msg.h"

static void
cleanup (void)
{
  ACE_DEBUG ((LM_INFO, "leaving (%P)!\n"));
}

static void
cause_error ()
{
  errno = EWOULDBLOCK;
  ACE_ERROR ((LM_DEBUG, "would block\n"));
}

int
main (int argc, char *argv[])
{
  // Note that the default behavior is to log to STDERR...

  if (ACE_LOG_MSG->open (argv[0]) == -1)
    ACE_ERROR ((LM_ERROR, "cannot open logger!!!\n"));

  cause_error ();
  if ((ACE_LOG_MSG->op_status () == -1) && 
      (ACE_LOG_MSG->errnum () == EWOULDBLOCK))
    cerr << "op_status and errnum work!" << endl;
  else
    cerr << "op_status and errnum FAILED!" << endl;

  // Exercise many different combinations of STDERR and OSTREAM. 

  ACE_DEBUG ((LM_INFO, "%f, %*s%s = %d\n", 
	     3.1416, 8, "", "hello", 10000));

  ACE_LOG_MSG->set_flags (ACE_Log_Msg::OSTREAM);
  ACE_LOG_MSG->msg_ostream (&cout);

  ACE_DEBUG ((LM_INFO, "%f, %*s%s = %d\n", 
	     3.1416 * 3.1416, 8, "", "world", 20000));

  ACE_LOG_MSG->clr_flags (ACE_Log_Msg::STDERR);

  ACE_DEBUG ((LM_INFO, "%f, %*s%s = %d\n", 
	     3.1416 * 3.1416, 8, "", "world", 20000));

  ACE_LOG_MSG->msg_ostream (0);

  ACE_LOG_MSG->set_flags (ACE_Log_Msg::STDERR);

  ACE_DEBUG ((LM_INFO, "%f, %*s%s = %d\n", 
	     3.1416 * 3.1416, 8, "", "world", 20000));

  ACE_LOG_MSG->clr_flags (ACE_Log_Msg::OSTREAM);
  ACE_LOG_MSG->msg_ostream (&cerr);

  ACE_DEBUG ((LM_INFO, "%f, %*s%s = %d\n", 
	     3.1416 * 3.1416, 8, "", "world", 20000));

  char *badname = "/badname";

  char *l_argv[2];
  l_argv[0] = badname;
  l_argv[1] = 0;
  if (ACE_OS::execv (badname, l_argv) == -1)
    ACE_ERROR ((LM_ERROR, "%n: (%x), %p%r%a\n", 
	       10000, badname, cleanup, 1));
  return 0;
}

